<?php
// +---------------------------------------------------------------------------+
// | This file is part of the KnowledgebasePublisher package                   |
// | KnowledgebasePublisher - web based knowledgebase publisher tool           |
// |                                                                           |
// | Author:  Evgeny Leontev <eleontev@gmail.com>                              |
// | Copyright (c) 2005 Evgeny Leontev                                         |
// |                                                                           |
// | For the full copyright and license information, please view the LICENSE   |
// | file that was distributed with this source code.                          |
// +---------------------------------------------------------------------------+


require_once 'config.inc.php';
require_once 'common.inc.php';

$db = &DBUtil::connect($conf);


$controller = &new AppController();
$controller->setWorkingDir();


$reg =& Registry::instance();
$reg->setEntry('db', $db);
$reg->setEntry('tbl_pref', $conf['tbl_pref']);
$reg->setEntry('limit', $conf['limit']);
$reg->setEntry('controller', $controller);
$reg->setEntry('conf', $conf);

$priv = new AuthPriv();
$priv->spentTime($conf['spent_time']);
if(!$priv->isAuth() || !$_GET) {
	header('Location:' . APP_HOME_PATH . 'logout.php');
	exit();
}       

//$module
$priv_area = $priv->getPrivArea($controller->module, $controller->page, $controller->sub_page);
$priv->setPrivArea($priv_area); 
$reg->setEntry('priv', $priv);


$nav = new AppNavigation; 
$nav->setEqualAttrib('GET', $controller->getRequestKey('page'));
$nav->setSubEqualAttrib('GET', $controller->getRequestKey('sub_page'));
$nav->setGetParams(sprintf('%s=%s', $controller->getRequestKey('module'), $controller->module));
$nav->setTemplate(APP_TMPL_DIR . 'sub_menu_img.html');
$nav->setTemplateCustomRule(true);

$nav->setMenuMsg(AppMsg::getMenuMsgs(false, false, false));
$nav->setMenu($controller->module);
$menu = &$nav->generate();


// generate
require_once ($controller->working_dir . 'PageController.php');
require_once 'core/app/PageRenderer.php';


$page = &new PageRenderer();
$page->template_dir = APP_TMPL_DIR;
$page->template = ($controller->getMoreParam('popup')) ? 'page_popup.html' :  'page.html';

$page->assign($conf);
$page->assign($conf['lang']);
$page->assign($view, 'content');
$page->assign($menu, 'menu');

$page->display();


if($conf['debug_info']) {
	echo getDebugInfo();
}

if($conf['debug_speed']) {
	timeprint("%min %max graf");
}

ob_end_flush();
?>