<?php
// +----------------------------------------------------------------------+
// | Author:  Evgeny Leontev <eleontev@ezactive.com>                      |
// | Copyright (c) 2005 Evgeny Leontev                                    |
// +----------------------------------------------------------------------+
// | This source file is free software; you can redistribute it and/or    |
// | modify it under the terms of the GNU Lesser General Public           |
// | License as published by the Free Software Foundation; either         |
// | version 2.1 of the License, or (at your option) any later version.   |
// |                                                                      |
// | This source file is distributed in the hope that it will be useful,  |
// | but WITHOUT ANY WARRANTY; without even the implied warranty of       |
// | MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU    |
// | Lesser General Public License for more details.                      |
// +----------------------------------------------------------------------+

class PageRenderer
{

	var $title_delim = ' / ';
	var $template_dir;
	var $template = 'page.html';
	var $emgine;
	
	var $header;
	var $menu;
	var $meta_title;
	var $meta_charset;
	var $vars = array();
	
	
    function PageRenderer(&$view, $engine = 'tpl_templatez') {
        
		$this->view = &$view;
		$this->engine = $engine;
		$this->template_dir = APP_TMPL_DIR;
    }
	
	
	function setEngine() {
		
	}
	
	
	 function render() {
			
		$tpl = &new tplTemplatez($this->template_dir . $this->template);
		
		$data['header'] = $this->getHeader();
		$data['menu'] = $this->getMenu();		
		$data['content'] = $this->view;
		$data['meta_title'] = $this->getMetaTitle();
		$data['meta_charset'] = $this->getMetaCharset();

		$tpl->tplParse(array_merge($data, $this->conf, $this->vars));
		return $tpl->tplPrint(1);			
	}	
	
	
	function assign($var, $value = false) {
		
		if(is_array($var)) {
			foreach($var as $k => $v) {
				$this->vars[$k] = $v;
			}
		} else {
			if($value === false) {
				trigger_error($this->error_pref. " Can't assign value for var - <b>".$var."</b>. Missing argument 2 for tplAssign();");
			} else { 
				$this->vars[$var] = $value; 
			}
		}
	}
	
	
	function setTemplate($var) {
		$this->template = $var;
	}
	
	
	function getHeader() {
		return $this->header;
	}
	
	
	function getMenu() {
		return $this->menu;
	}
	
	
	function getMetaTitle() {
		return $this->meta_title;
	}
	
	
	function getMetaCharset() {
		return $this->conf['lang']['meta_charset'];
	}
	
	
	function display() {
		echo $this->render();
	}
}


class PageRenderer_templates extends PageRenderer
{
	
}
?>