<?php
// +---------------------------------------------------------------------------+
// | This file is part of the KnowledgebasePublisher package                   |
// | KnowledgebasePublisher - web based knowledgebase publisher tool           |
// |                                                                           |
// | Author:  Evgeny Leontev <eleontev@gmail.com>                              |
// | Copyright (c) 2005 Evgeny Leontev                                         |
// |                                                                           |
// | For the full copyright and license information, please view the LICENSE   |
// | file that was distributed with this source code.                          |
// +---------------------------------------------------------------------------+

class KBEntry extends AppObj
{
	
	var $properties = array('id'		 	=> NULL,
							'author_id' 	=> '',
							'updater_id'	=> '',
							'title'	 		=> '',
							'body' 			=> '',
							'date_posted'	=> '',
							//'date_updated'	=> '',							
							'hits'			=> 0,
							'active'		=> '1'
							);
	
	var $hidden = array('id', 'author_id', 'updater_id', 'date_posted', 'hits');
	var $category = array();
	var $attachment = array();
	
	
	function setCategory($val) {
		$this->category = &$val;
	}
	
	function &getCategory() {
		return $this->category;
	}
	
	function setAttachment($val) {
		$this->attachment = &$val;
	}
	
	function &getAttachment() {
		return $this->attachment;
	}	

	
	function _callBack($property, $val) {
		if($property == 'date_posted' && !$val) {
			$val = date('Y-m-d');
			
		//} elseif($property == 'date_updated') {
		//	$val = $val = date('Y-m-d');
		
		} elseif($property == 'author_id' && !$val) {
			$val = $_SESSION['auth_']['user_id'];
		
		} elseif($property == 'updater_id') {
			$val = $_SESSION['auth_']['user_id'];
		}  
		
		return $val;
	}
	
	
	function validate($values) {
		
		require_once 'eleontev/Validator.php';
		
		$required = array('title', 'body', 'category');
		
		$v =& new Validator($values, false);

		// check for required first, return errors
		$v->requiredArray('required_msg', $required);
		if($v->getErrors()) {
			$this->errors =& $v->getErrors();
			return true;
		}
	}
}
?>