<?php
// +---------------------------------------------------------------------------+
// | This file is part of the KnowledgebasePublisher package                   |
// | KnowledgebasePublisher - web based knowledgebase publisher tool           |
// |                                                                           |
// | Author:  Evgeny Leontev <eleontev@gmail.com>                              |
// | Copyright (c) 2005 Evgeny Leontev                                         |
// |                                                                           |
// | For the full copyright and license information, please view the LICENSE   |
// | file that was distributed with this source code.                          |
// +---------------------------------------------------------------------------+

class KBEntryView_list extends AppView
{
	
	var $template = 'list.html';
	
	
	function execute(&$obj, &$manager) {
		
		//$this->setShortMsg('attachment_num_msg', 3);
		//$this->setShortMsg('comment_num_msg', 4);
		
		
		$tpl = &new tplTemplatez($this->template_dir . $this->template);
		
		//$search = &$this->searchForm();
		//$this->manager->setSqlParams($search['sql']);
		
		// sort generate
		$sort = &$this->getSort();
		
		// filter sql
		$manager->setSqlParams($this->getFilterSql());
		
		// header generate
		$bp = &$this->pageByPage($manager->limit, $manager->getCountRecordsSql());
		$tpl->tplAssign('header', $this->commonHeaderList($bp->nav, 
		                                                  $this->getFilter($manager), 
														  true));
		
		// get records
		$manager->setSqlParamsOrder($sort->getSql());
		$rows =& $manager->getRecords($bp->limit, $bp->offset);
		//echo "<pre>"; print_r($rows); echo "</pre>";
		
		
		// get categories
		foreach($rows as $row) { $ids[] = $row['id']; }
		if(@$ids) {
			$ids = implode(',', $ids);
			$categories =& $manager->getCategoryByIds($ids);		
		} else {
			$categories = array();
		}

		
		
		// list records
		foreach($rows as $row) {
			
			$obj->set($row);
			
			$tpl->tplAssign('formated_date', $this->getFormatedDate($row['ts']));
			$tpl->tplAssign('category', implode('<br>', $categories[$row['id']]));
			$tpl->tplAssign('comment_num', $row['comment_num']);
			$tpl->tplAssign('attachment_num', $row['attachment_num']);
			$tpl->tplAssign('votes', $row['votes']);			
			$tpl->tplAssign('rating_img', $this->getRatingImg($row['rating'], $row['votes']));			

			$tpl->tplAssign($this->getViewListVars($obj->get('id'), $obj->get('active')));
			
			$tpl->tplParse(array_merge($obj->get(), $this->msg), 'row');
		}
		
		$tpl->tplAssign($this->msg);
		$tpl->tplAssign($sort->toHtml());
		
		$tpl->tplParse();
		return $tpl->tplPrint(1);
	}
	
	
	function &getSort() {
		//$sort = new TwoWaySort();
		$sort = new OneWaySort($_GET);
		$sort->default_order = 2;
		$sort->setTitleMsg('asc',  $this->msg['sort_asc_msg']);
		$sort->setTitleMsg('desc', $this->msg['sort_desc_msg']);
		$sort->setSortItem('votes_num_msg',  'votes', 'votes', $this->msg['votes_num_msg']);
		$sort->setSortItem('rating_msg',  'rating', 'rating', $this->msg['rating_msg']);
		$sort->setSortItem('entry_title_msg',  'title', 'title', $this->msg['entry_title_msg']);
		$sort->setSortItem('comment_num_msg', 'comments', 'comment_num', $this->msg['comment_num_msg']);
		$sort->setSortItem('files_num_msg', 'attachments', 'attachment_num', $this->msg['files_num_msg']);		
		$sort->setSortItem('hits_num_msg', 'hits', 'hits', $this->msg['hits_num_msg']);
		$sort->setSortItem('date_posted_msg', 'date', 'date_posted', $this->msg['date_posted_msg'], 1);
		$sort->setSortItem('status_msg','status', 'active', $this->msg['status_msg']);
		//$sort->setSortItem('category_msg','cat', 'category_name', $this->msg['category_msg']);
		
		//$sort->getSql();
		//$sort->toHtml()
		return $sort;
	}
	
	
	function getFilter($manager) {

		$select = new FormSelect();
		$select->css_class = 'colorInput';
		$select->setSelectWidth(250);
		$select->setOnChangeSubmit(true);
		$select->setSelectName('filter');
		$select->setRange($manager->getCategorySelectRange(), array('all'=>$this->msg['all_categories_msg']));
		
		$arr = $_GET; unset($arr[$select->select_name]);		

		
		$html = '<form action="" style="margin: 0px;">';
		$html .= http_build_hidden($arr);
		$html .= $select->select();
		$html .= '</form>';
		
		return $html;
	}
	
	
	function getFilterSql() {
		
		// filter
		$arr = array();
		if(isset($_GET['filter']) && $_GET['filter'] != 'all') {
			$category_id = (int) $_GET['filter'];
			$arr[] = "AND e_to_cat.category_id = '$category_id '";
		}
		
		return implode(" \n", $arr);
	}
	
	
	function getRatingImg($rate, $votes) {
		$str = '<img src="images/rating/rate_line_8px/rate_%s.gif" alt="" border="0">';
		$rate = round($rate);
		return ($votes) ? sprintf($str, $rate) : '';
	}
	
	
	function getViewListVars($record_id = false, $active = false) {
		
		$row = parent::getViewListVars($record_id, $active);
		
		$row['attachment_link'] = sprintf('%s&%s=upload&id=%d', $row['common_link'], 'action', $record_id);
		return $row;		
	}
}
?>