<?
// +---------------------------------------------------------------------------+
// | This file is part of the KnowledgebasePublisher package                   |
// | KnowledgebasePublisher - web based knowledgebase publisher tool           |
// |                                                                           |
// | Author:  Evgeny Leontev <eleontev@gmail.com>                              |
// | Copyright (c) 2005 Evgeny Leontev                                         |
// |                                                                           |
// | For the full copyright and license information, please view the LICENSE   |
// | file that was distributed with this source code.                          |
// +---------------------------------------------------------------------------+

require_once APP_ROOT_DIR . 'modules/knowledgebase/entry/inc/KBEntryModel.php';
require_once APP_ROOT_DIR . 'modules/knowledgebase/comment/inc/KBCommentModel.php';
require_once APP_ROOT_DIR . 'modules/knowledgebase/category/inc/KBCategoryModel.php';
require_once APP_ROOT_DIR . 'modules/knowledgebase/comment/inc/KBCommentView_helper.php';


class KBHomeView_default extends AppView
{
	
	var $num = 10;
	
	function execute() {
		
		$tpl = &new tplTemplatez($this->template_dir . 'page.html');
		$tpl->tplAssign('most_viewed', $this->getMostViewedQuestions());
		$tpl->tplAssign('recently_posted', $this->getRecentlyPostedComments());
		$tpl->tplAssign('quick_link', $this->getQuickLinks());		
		
		$tpl->tplParse();
		return $tpl->tplPrint(1);
	}
	
	
	function getMostViewedQuestions() {
		
		$entry = &new KBEntryModel;
		$entry->setSqlParamsOrder('ORDER BY hits DESC');
		$rows = &$entry->getRecords(10, 0);
		
		$tpl = &new tplTemplatez($this->template_dir . 'most_viewed.html');
		
		foreach($rows as $k => $v) {
			
			$link = array();			
			$link[] = sprintf('%s=%s', $this->controller->query['module'], 'knowledgebase');
			$link[] = sprintf('%s=%s', $this->controller->query['page'], 'kb_entry');
			$link[] = sprintf('%s=%s', $this->controller->query['action'], 'update');
			$link[] = sprintf('%s=%s', $this->controller->query['id'], $v['id']);
			
			$v['entry_link'] = $_SERVER['PHP_SELF'] . '?' . implode('&', $link);
		
			$tpl->tplParse($v, 'row');
		}
		
		$tpl->tplAssign($this->msg);
		$tpl->tplParse();
		return $tpl->tplPrint(1);
	}
	
	
	function getRecentlyPostedComments() {
		
		$entry = &new KBCommentModel;
		$entry->setSqlParamsOrder('ORDER BY date_posted DESC');
		$rows = &$entry->getRecords(10, 0);
		
		//BB CODE
		$parser = &KBCommentView_helper::getBBCodeObj();
		
		$tpl = &new tplTemplatez($this->template_dir . 'recently_posted_comment.html');
		
		foreach($rows as $k => $v) {
		
			$link = array();		
			$link[] = sprintf('%s=%s', $this->controller->query['module'], 'knowledgebase');
			$link[] = sprintf('%s=%s', $this->controller->query['page'], 'kb_comment');
			$link[] = sprintf('%s=%s', $this->controller->query['action'], 'update');
			$link[] = sprintf('%s=%s', $this->controller->query['id'], $v['id']);
			
			$v['entry_link'] = $_SERVER['PHP_SELF'] . '?' . implode('&', $link);
			$v['status_num'] = $v['active'] ? '1' : '0';			
			$v['comment'] =  $parser->qparse($v['comment']);			
			
			$tpl->tplParse($v, 'row');
		}
		
		$tpl->tplAssign($this->msg);
		$tpl->tplParse();
		return $tpl->tplPrint(1);
	}
	
	
	function getQuickLinks() {
	
		$tpl = &new tplTemplatez($this->template_dir . 'quick_link.html');
		
		
		$link[1] = sprintf('%s=%s', $this->controller->query['module'], 'knowledgebase');
		$link[2] = sprintf('%s=%s', $this->controller->query['action'], 'insert');
		
		$link[3] = sprintf('%s=%s', $this->controller->query['page'], 'kb_entry');
		$tpl->tplAssign('entry_link', $_SERVER['PHP_SELF'] . '?' . implode('&', $link));
		
		$link[3] = sprintf('%s=%s', $this->controller->query['page'], 'kb_category');		
		$tpl->tplAssign('category_link', $_SERVER['PHP_SELF'] . '?' . implode('&', $link));		
		
		$link[3] = sprintf('%s=%s', $this->controller->query['page'], 'kb_glossary');			
		$tpl->tplAssign('glossary_link', $_SERVER['PHP_SELF'] . '?' . implode('&', $link));					
		
		$tpl->tplAssign($this->msg);
		$tpl->tplParse();
		return $tpl->tplPrint(1);
	}
	
}

/*
Total Questions: 69
Total Visible: 63 
Total Hidden: 6
Total Categories: 72
Total Root: 38 
Total Sub: 34
Total Glossary Words: 34 
Total Comments: 162
Total Approved: 150 
Total Disapproved: 12 
Total Pending: 0
*/

// Recently Posted Comments
?>
