<?php
// +---------------------------------------------------------------------------+
// | This file is part of the KnowledgebasePublisher package                   |
// | KnowledgebasePublisher - web based knowledgebase publisher tool           |
// |                                                                           |
// | Author:  Evgeny Leontev <eleontev@gmail.com>                              |
// | Copyright (c) 2005 Evgeny Leontev                                         |
// |                                                                           |
// | For the full copyright and license information, please view the LICENSE   |
// | file that was distributed with this source code.                          |
// +---------------------------------------------------------------------------+

class MemberModel extends AppModel
{

	var $tbl_pref_custom = '';
	var $tables = array('table'=>'member', 'member');
	var $custom_tables = array('entry'=>'kb_entry');
	
	
	function & getById($record_id) {
		$sql = "SELECT *, UNIX_TIMESTAMP(date_registered) AS ts
		FROM {$this->tbl->member} 
		WHERE id = ?";
		$result =& $this->db->Execute($sql, $record_id) or die(db_error($sql));
		return $result->FetchRow();
	}
	
	
	function getRecordsSql() { 
		//SQL_CALC_FOUND_ROWS
		$sql = "SELECT *, UNIX_TIMESTAMP(date_registered) AS ts
		FROM {$this->tbl->member} 
		WHERE {$this->sql_params}";
		return $sql;
	}
	
	
	function save(&$obj, $grantor = false) {
		
		if(!$obj->get('id')) {
			
			$user_id = $this->add($obj);
			
		} else {
			
			$this->update($obj);
			$user_id = $obj->get('id');
		}
	}	
	
	// VALIDATING // -------------------------
	
	// return true if we already have such username false otherwise
	function isUsernameExists($username, $id = false) {
		
		$cond = ($id) ? "id != '$id'" : "1=1"; 
		
		$sql = "SELECT 1 FROM {$this->tbl->member} WHERE username = '$username' AND $cond";
		$result =& $this->db->Execute($sql) or die(db_error($sql));
		return (bool) ($result->Fields(1));
	}
	
	
	// return true if we already have such email false otherwise
	function isEmailExists($email, $id = false) {
		
		$cond = ($id) ? "email != '$email'" : "1=1"; 
		
		$sql = "SELECT 1 FROM {$this->tbl->member} WHERE email = '$email' AND $cond";
		$result =& $this->db->Execute($sql) or die(db_error($sql));
		return (bool) ($result->Fields(1));
	}
	
	
	
	// DELETE RELATED // ---------------------
	
}
?>
