<?
// +---------------------------------------------------------------------------+
// | This file is part of the KnowledgebasePublisher package                   |
// | KnowledgebasePublisher - web based knowledgebase publisher tool           |
// |                                                                           |
// | Author:  Evgeny Leontev <eleontev@gmail.com>                              |
// | Copyright (c) 2005 Evgeny Leontev                                         |
// |                                                                           |
// | For the full copyright and license information, please view the LICENSE   |
// | file that was distributed with this source code.                          |
// +---------------------------------------------------------------------------+

class SettingView_form extends AppView
{
	
	var $tmpl = 'form.html';
	
	
	
	function execute(&$obj, &$manager) {
		
		$tpl = &new tplTemplatez($this->template_dir . $this->tmpl);
		$tpl->tplAssign('error_msg', AppMsg::errorBox($obj->errors, $manager->module_name));
		
		$form_data = $this->parseMultiIni($this->template_dir . 'form.ini');
		
		$file = AppMsg::getModuleMsgFile($manager->module_name, 'setting_msg.ini');
		$setting_msg = AppMsg::parseMsgs($file);
		
		
		$r = new Replacer();
		//$r->assignVars('yes_msg', $this->msg['yes_msg']);
		
		
		$select = new FormSelect();
		//$select->select_width = '300';
		$select->select_tag = false;
		
		$rows = &$manager->getRecords();
		
		foreach($rows as $setting_key => $v) {
			
			$setting_key = trim($setting_key);
			
			if($v['input'] == 'checkbox' && $obj->get($setting_key) == 1) {
				$v['checked'] = 'checked';
			
			} elseif ($v['input'] == 'select') {
				
				// we have options in lang file
				if(isset($setting_msg[$v['setting_key']]['option_1'])) {
					$options = $setting_msg[$v['setting_key']];
					unset($options['title'], $options['descr']);
					foreach($v['range'] as $k1 => $v1) {
						$k1 = trim($k1);
						$v['range'][$k1] = trim(current($options));
						next($options);
					}
				}
				
				$select->setRange($v['range']);
				$v['value'] = $select->select($obj->get($setting_key));
				unset($v['range']);
			
			} else {
				
				$v['value'] = $obj->get($setting_key);
			}			 
			
			$field = $r->parse($form_data[$v['input']], $v);
			
			$tpl->tplAssign('title_msg', $setting_msg[$v['setting_key']]['title']);
			$tpl->tplAssign('description_msg', $setting_msg[$v['setting_key']]['descr']);			
			$tpl->tplAssign('form_input', $field);
			$tpl->tplParse($v, 'row');
		}
		
		//$tpl->tplAssign($this->setCommonFormVars($obj));
		//$tpl->tplAssign($obj->get());
		$tpl->tplAssign($this->msg);
		
		$tpl->tplParse();
		return $tpl->tplPrint(1);
	}
	
	
	// reassigned from AppView
	//function setModuleMsg() {
	//	$file = AppMsg::getModuleMsgFile($manager->module_name, 'setting_msg.ini');
	//	$this->msg_setting = GetMsgHelper::parseIni($file);
	//}
	
	
	// parse multilines ini file
	// it will skip all before defining first [block] 
	function & parseMultiIni($file, $key = false) {
		$s_delim = '[%';
		$e_delim = '%]'; 
		
		$str = implode('',file($file));
		if($key && strpos($str, $s_delim . $key . $e_delim) === false) { return; } 
		
		$str = explode($s_delim, $str);
		$num = count($str);
			
		for($i=1;$i<$num;$i++){
			$section = substr($str[$i], 0, strpos($str[$i], $e_delim));
			$arr[$section] = substr($str[$i], strpos($str[$i], $e_delim)+strlen($e_delim));
		}
		
		return ($key) ? @$arr[$key] : $arr;
	}
}
?>