<?php
// +---------------------------------------------------------------------------+
// | This file is part of the KnowledgebasePublisher package                   |
// | KnowledgebasePublisher - web based knowledgebase publisher tool           |
// |                                                                           |
// | Author:  Evgeny Leontev <eleontev@gmail.com>                              |
// | Copyright (c) 2005 Evgeny Leontev                                         |
// |                                                                           |
// | For the full copyright and license information, please view the LICENSE   |
// | file that was distributed with this source code.                          |
// +---------------------------------------------------------------------------+

require_once 'phpmailer/class.phpmailer.php';


class KBClientMailer
{
	
	var $template_dir =  APP_EMAI_TMPL_DIR;
	var $msg = array();
	var $from_site;
	var $from_noreplay_email;
	
	
	
	function KBClientMailer($view) {
		$this->setMsg($view);
		$this->from_site = $_SERVER['HTTP_HOST'];
		$this->from_noreplay_email = 'noreply@' . $_SERVER['HTTP_HOST'];
	}
	
	
	function setMsg($view) {
		$file = $view->getMsgFile('email_msg.ini');
		$this->msg = AppMsg::parseMsgs($file);
	}
	
	
	// to support about new user question
	function sendEntryNotification($vars, $to) {
		
		$msg = $this->msg['new_entry'];
		
		$mail = new PHPMailer();
		$mail->From = $vars['email'];
		$mail->FromName = $vars['name'];
		$mail->Subject = $msg['subject'];
		$mail->AddAddress($to); // name can be used for second argument
		
		
		$tpl = new tplTemplatez($this->template_dir . 'kb_new_entry.txt');
		$tpl->clean_html = false;
		
		$tpl->tplAssign('name', $vars['name']);
		$tpl->tplAssign('email', $vars['email']);
		$tpl->tplAssign('body', $vars['message']);	 
		
		$tpl->tplParse($msg);
		
		//echo "<pre>"; print_r($tpl->tplPrint(1)); echo "</pre>";
		//exit();
		
		$mail->Body = $tpl->tplPrint(1);	
		return $mail->Send();
	}
	
	
	function sendToFriend($vars) {
		
		$msg = $this->msg['send_friend'];
		
		require_once 'eleontev/Util/Replacer.php';
		$r = new Replacer();
		$msg['welcome_msg'] = $r->parse($msg['welcome_msg'], array('name'=>$vars['name']));		
		
		
		$mail = new PHPMailer();
		$mail->From = $vars['your_email'];
		$mail->FromName = $vars['name'];
		$mail->Subject = $msg['subject'];
		$mail->AddAddress($vars['friend_email']); // name can be used for second argument
		
		
		$tpl = new tplTemplatez($this->template_dir . 'kb_to_friend.txt');
		$tpl->clean_html = false;
		
		$tpl->tplAssign('entry_title', $vars['entry_title']);
		$tpl->tplAssign('link', $vars['entry_link']);
		$tpl->tplAssign('body', $vars['comment']);
		
		$tpl->tplParse($msg);
		
		//echo "<pre>"; print_r($tpl->tplPrint(1)); echo "</pre>";
		//exit();
		
		$mail->Body = $tpl->tplPrint(1);
		return $mail->Send();
	}
	
	
	function sendConfirmRegistration($vars) {
		
		$msg = $this->msg['confirm_registration'];
		
		$mail = new PHPMailer();
		$mail->From = $this->from_noreplay_email;
		$mail->FromName = '';
		$mail->Subject = $msg['subject'];
		$mail->AddAddress($vars['email']); // name can be used for second argument
		
		
		$tpl = new tplTemplatez($this->template_dir . 'confirm_registration.txt');
		$tpl->clean_html = false;
		
		$tpl->tplAssign('login', $vars['username']);		
		$tpl->tplAssign('password', $vars['password']);		
		$tpl->tplAssign('link', $vars['confirm_link']);
		$tpl->tplParse($msg);
		
		$mail->Body = $tpl->tplPrint(1);
		
		//echo "<pre>"; print_r($tpl->tplPrint(1)); echo "</pre>";
		//echo "<pre>"; print_r($mail); echo "</pre>";
		//exit();
			
		return $mail->Send();
	}
	
/*	
	function newCommentPosted($data) {
		
		$param = 'page=message&action=detail&item_id=' . $item_id . '&go=1';
		$go_link = APP_HOME_PATH . 'account.php?' . $param;
		
		$mail = new PHPMailer();
		$mail->From = $data['email'];
		$mail->FromName = $data['name'];
		$mail->Subject = $this->msg['new_comment_subject_msg'];
		$mail->AddAddress(APP_ADMIN_EMAIL); // name can be used for second argument
		 
		$tpl = &new tplTemplatez($this->controller->working_dir . 'email_template/notify_about_comment.txt');
		$tpl->clean_html = false;
		
		$tpl->tplAssign('name', PersonHelper::getEmailName($user['first_name'], $user['last_name']));
		$tpl->tplAssign('item_title', $item['title']); 
		$tpl->tplAssign('link', $link);
		$tpl->tplAssign('username', AuthMember::getUsername());
		$tpl->tplAssign('site_name', SITE_NAME);
		$tpl->tplAssign('support_email', SUPPORT_EMAIL);
		
		$tpl->tplParse();
		//echo "<pre>"; print_r($tpl->tplPrint()); echo "</pre>"; exit();
		
		$mail->Body = $tpl->tplPrint(1);
		return $mail->Send();
	}
*/	
	

/*
	function generatedPassword($password, $user) {
	
		$mail = new PHPMailer();
		$mail->From = SITE_NAME;
		$mail->FromName = SUPPORT_EMAIL;
		$mail->Subject = 'Generated password';
		$mail->AddAddress($user['email']); // name can be used for second argument
		
		$tpl = &new tplTemplatez(APP_EMAI_TMPL_DIR . 'generated_password.txt');
		$tpl->clean_html = false;
		
		$tpl->tplAssign('name', $user['first_name'] . ' ' . $user['last_name']);
		$tpl->tplAssign('username', $user['username']);
		$tpl->tplAssign('password', $password);
		$tpl->tplAssign('site_name', SITE_NAME);
		$tpl->tplAssign('support_email', SUPPORT_EMAIL);
		
		$tpl->tplParse();
		$mail->Body = $tpl->tplPrint(1);
		//echo "<pre>"; print_r($tpl->tplPrint()); echo "</pre>"; //exit();
				
		return $mail->Send();

	}
*/
}
?>