<?php
// +---------------------------------------------------------------------------+
// | This file is part of the KnowledgebasePublisher package                   |
// | KnowledgebasePublisher - web based knowledgebase publisher tool           |
// |                                                                           |
// | Author:  Evgeny Leontev <eleontev@gmail.com>                              |
// | Copyright (c) 2005 Evgeny Leontev                                         |
// |                                                                           |
// | For the full copyright and license information, please view the LICENSE   |
// | file that was distributed with this source code.                          |
// +---------------------------------------------------------------------------+

$entry_id    = (int) $controller->getRequestVar('entry_id');
$category_id = (int) $controller->getRequestVar('category_id');
$view_id     = $controller->getRequestVar('view');
$msg_id      = $controller->getRequestVar('msg');


$rq = &new RequestData($_GET);
$rp = &new RequestData($_POST);


switch ($view_id) {
case 'print': // ------------------------------
	
	require_once $dir . 'KBClientView_print.php';
	
	$view = new KBClientView_print($controller);
	echo $view->execute($manager);
	exit();
	break;
	

case 'success_go':
	
	require_once $dir . 'KBClientView_success_go.php';
	
	$view = &new KBClientView_success_go($controller);
	echo $view->execute($manager);
	exit();
	break;		
	
	
case 'success': // ------------------------------
	
	require_once $dir . 'KBClientView_success.php';
	$view = &new KBClientView_success($controller);
	
	break;	

	
case 'welcome': // ------------------------------
	
	require_once $dir . 'KBClientView_welcome.php';
	$view = &new KBClientView_welcome($controller);
	
	break;	


case 'logout': // ------------------------------
	
	AuthMember::logout();
	$controller->go();
	
	break;	
	

case 'glossary': // ------------------------------
	
	// check if registration is not required
	if(!$manager->getSetting('show_glossary_link')) {
		$controller->go();
	}
	
	require_once $dir . 'KBClientView_glossary.php';
	$view = &new KBClientView_glossary($controller);

	break;	
	
	
case 'search': // ------------------------------
	
	require_once $dir . 'KBClientView_search.php';
	$view = &new KBClientView_search($controller);

	break;

	
case 'confirm': // ------------------------------
	
	$user_id = $manager->isUser($rq->ec);
	if($user_id) {
		$manager->setUserActive($user_id);
		$controller->go('success_go', false, false, 'registration_confirmed');
	} else {
		$controller->go('success_go', false, false, 'registration_not_confirmed');
	}
	
	break;
	
	
case 'password': // ------------------------------
	
	require_once $dir . 'KBClientView_password.php';
	$view = &new KBClientView_password($controller);
	
	if(isset($rp->submit)) {
		
		$pass = new PasswordUtil;
		$pass->table = $manager->tbl->user;	
		
		$v =& new Validator($rp->vars, false);
		$v->regex('email_msg', 'email', 'email');
	
		$user_id = $pass->isEmailExists($rp->vars['email']);
		if(!$user_id) { $v->setError('email_not_exists_msg', '1'); } 
		
		if($v->getErrors()) {

			$rp->stripVars(true);
			$view->setErrors($v->getErrors());
			$view->setFormData($rp->vars);
		
		} else {
			
			$user = $manager->getUserInfo($user_id);
			$password = $pass->generatePassword();
			$sent = $manager->sendNewPassword($password, $user);
			
			if($sent) {
				
				$rp->stripVars();
				$pass->setPassword($user_id, MD5($password));
				$controller->go('success_go', false, false, 'password_sent');
			
			} else {
				
				$rp->stripVars(true);
				$view->setFormData($rp->vars);
				
				$file = AppMsg::getCommonMsgFile('error_msg.ini');
				$msg = AppMsg::parseMsgs($file);
								
				$msgs['title'] = $msg['unexpected_title_msg'];
				$msgs['body'] = $msg['pass_generate_error_msg'];
				
				$view->msg['user_msg'] = BoxMsg::factory('error', $msgs);
			}
		}
	}

	break;		

	
	
case 'login': // ------------------------------
	
	// check if registration is not required
	if(!$manager->isUseRegistration()) {
		$controller->go();
	}
	
	
	require_once $dir . 'KBClientView_login.php';
	$view = &new KBClientView_login($controller);
	
	if($msg_id == 'comment' || $msg_id == 'add_entry') {
		$view->msg_id = ($msg_id == 'comment') ? 'need_to_login_comment' : 'need_to_login_entry';
	}
	
	if(isset($rp->submit)) {
		
		$errors = $view->validate($rp->vars, $manager);
		
		if($errors) {

			$rp->stripVars(true);
			$view->setErrors($errors);
			$view->setFormData($rp->vars);
		
		} else {
			
			$controller->go($msg_id, $category_id, $entry_id);
		}
	}
	
	break;
	
		
case 'register': // ------------------------------
case 'member':   // ------------------------------	
	
	// check if registration is not required
	if(!$manager->isUseRegistration()) {
		$controller->go();
	}
	
	// check if not registered
	if($view_id == 'member' && !$manager->is_registered) {
		$controller->go();
	}	
	
	// check if registered
	if($view_id == 'register' && $manager->is_registered) { 
		$controller->go();
	}		
	
	
	require_once $dir . 'KBClientView_register.php';
	$view = &new KBClientView_register($controller);
	$view->update = ($view_id == 'member');
	
	$manager_1 = new MemberModel;
	
	if(isset($rp->submit)) {
		
		$errors = $view->validate($rp->vars, $manager_1);
		
		if($errors) {

			$rp->stripVars(true);
			$view->setErrors($errors);
			$view->setFormData($rp->vars);
		
		} else {
			
			$rp->stripVars();
			$view->obj->set($rp->vars);
			
			if($view_id == 'register') {
				
				$sent = $manager->sendConfirmRegistration($rp->vars, $view);
				
				if(!$sent) {
					$view->obj->set('active', 0);
					$manager_1->save($view->obj);
					$msg = 'confirmation_sent';
				} else {
					$msg = 'confirmation_not_sent';
				}	
				
				$controller->go('success_go', false, false, $msg);
				
			} else {
				
				$view->obj->setPassword($rp->not_change_pass); // mean not insert in db if not_change_pass = 1
				
				$manager_1->save($view->obj);
			
				$auth = new AuthMember;
				if(!$rp->vars['remember']) { $auth->removeCookie(); }
				
				$controller->go('success_go', false, false, 'updated');
			}
		}
	
	} elseif($view_id == 'member') {
		
		$data = $manager_1->getById($manager->user_id);
		$view->setFormData($data);
	}
	
	break;
	
	
case 'send': // ------------------------------
	
	require_once $dir . 'KBClientView_send.php';
	$view = &new KBClientView_send($controller);
	
	if(isset($rp->submit)) {
		
		$errors = $view->validate($rp->vars);	

		if($errors) {

			$rp->stripVars(true);
			$view->setErrors($errors);
			$view->setFormData($rp->vars);
		
		} else {
			
			$rp->setHtmlValues('entry_link');
			$rp->stripVars(true);
			$manager->sendToFriend($rp->vars, $view);
			
			$controller->go('success_go', $category_id, $entry_id, 'friend_sent');
		}
	}
	
	break;
	

case 'entry': // ------------------------------
	
	require_once $dir . 'KBClientView_entry.php';
	$view = new KBClientView_entry($controller);
	
	if(isset($rp->do_rate)) {
		
		if($manager->isUserVoted($entry_id) === false && $rp->rate) {
		
			$manager->addVote($entry_id, $rp->rate);
			$manager->setUserVoted($entry_id);
		}
		
		// do redirect
		$controller->go('entry', $category_id, $entry_id);
	}
	
	
	if($manager->isUserViewed($entry_id) === false) {
		$manager->addView($entry_id);
		$manager->setUserViewed($entry_id);
	}
	
	break;

	
case 'comment': // ------------------------------	
	
	// need to login
	if(!$manager->is_registered && $manager->getSetting('allow_comments') == 2) { 
		$controller->go('login', $category_id, $entry_id, 'comment');
	}
	
	// if not allowed
	if(!$manager->getSetting('allow_comments')) {
		$controller->go('entry', $category_id, $entry_id);
	}
	
	
	require_once $dir . 'KBClientView_add_comment.php';
	$view = &new KBClientView_add_comment($controller);

	if(isset($rp->submit)) {
		
		$errors = $view->validate($rp->vars, $manager);
		$flood = $manager->isFlood();
		
		if($errors) {

			$rp->stripVars(true);
			$view->setErrors($errors); 
			$view->setFormData($rp->vars);
		
		} elseif($flood) {
		
			$rp->stripVars(true);
			$view->setFormData($rp->vars);
			$view->msg_id = 'flood_comment';		
		
		} else {
		
			$rp->stripVars();
			$manager->addComment($entry_id, $rp->vars);
			
			$msg = ($manager->getSetting('comment_status')) ? 'comment_posted' : 'comment_wait'; 
			$controller->go('success_go', $category_id, $entry_id, $msg);
		}
	}

	break;


// when it is enable need to set flood check 
case 'add_entry': // ------------------------------

	// need to login
	if(!$manager->is_registered && $manager->getSetting('allow_post_entry') == 2) { 
		$controller->go('login', $category_id, false, 'add_entry'); 
	}
	
	// if not allowed
	if(!$manager->getSetting('allow_post_entry')) {
		$controller->go();
	}
	
	

	break;
	
	
//case 'category': // ------------------------------	
default: // ------------------------------------
	
	require_once $dir . 'KBClientView_default.php';
	$view = &new KBClientView_default($controller);
}
?>